/*
  
 $1 -  
 $2 - depth from 
 $3 - depth to
 $4 - well id
 $5 - params
*/

(select distinct on(paramname) 1 as t,depth, w.paramname as paramname, w.val->>'val' as val
   FROM dcdm_welllog w inner join dcdm_acgroupsfld a on a.name=w.paramname
  where a.acgroupid=$1
    and (w.isnew is null or w.isnew=false)
    and w.wellid=$4
	and w.paramname=any(string_to_array($5,','))
    and w.depth <= $2
  order by paramname,depth desc)
union all
(select distinct on(paramname) 2 as t,depth, w.paramname as paramname, w.val->>'val' as val
   FROM dcdm_welllog w inner join dcdm_acgroupsfld a on a.name=w.paramname
  where a.acgroupid=$1
    and (w.isnew is null or w.isnew=false)
    and w.wellid=$4
	and w.paramname=any(string_to_array($5,','))
    and w.depth <= $3
  order by paramname,depth desc)
union all
(SELECT 3 as t,w.depth, w.paramname, val->>'val' as val
FROM dcdm_welllog w inner join dcdm_acgroupsfld a on a.name=w.paramname
where a.acgroupid=$1
      and (w.isnew is null or w.isnew=false)
      and depth>$3
      and wellid=$4
	  and paramname=any(string_to_array($5,','))
order by w.depth limit 1);

